<?php

/**
 * Haraiso - the PHP Validation Framework
 *
 * PHP version 5
 *
 * @category  Haraiso
 * @package   Haraiso
 * @link      http://bitbucket.org/localdisk/haraiso/
 * @author    MATSUO Masaru
 * @copyright 2010 MATSUO Masaru
 * @license   http://opensource.org/licenses/bsd-license.php New BSD License
 *
 */
/**
 * Message
 *
 * @package   Haraiso
 * @author    MATSUO Masaru
 */
class Message {

    /**
     * name
     *
     * @var string
     */
    private $_name;
    /**
     * value
     *
     * @var string
     */
    private $_value;
    /**
     * message
     *
     * @var string
     */
    private $_message;

    /**
     * Constructor
     *
     * @param string $name
     * @param string $value
     * @param string $message
     */
    public function __construct($name = null, $value = null, $message = null) {
        if ($name !== null)    $this->_name = $name;
        if ($value !== null)   $this->_value = $value;
        if ($message !== null) $this->_message = $message;
    }

    /**
     * getName
     *
     * @return string
     */
    public function getName() {
        return $this->_name;
    }

    /**
     * setName
     *
     * @param  string $name
     * @return Message
     */
    public function setName($name) {
        $this->_name = $name;
        return $this;
    }

    /**
     * getValue
     *
     * @return string
     */
    public function getValue() {
        return $this->_value;
    }

    /**
     * setValue
     *
     * @param  string $value
     * @return Message
     */
    public function setValue($value) {
        $this->_value = $value;
        return $this;
    }

    /**
     * getMessage
     *
     * @return string
     */
    public function getMessage() {
        return $this->_message;
    }

    /**
     * setMessage
     * @param  string $message
     * @return Message
     */
    public function setMessage($message) {
        $this->_message = $message;
        return $this;
    }
}