<?php
/**
 * Haraiso - the PHP Validation Framework
 *
 * PHP version 5
 *
 * @category  Haraiso
 * @package   Haraiso/validator
 * @link      http://bitbucket.org/localdisk/haraiso/
 * @author    MATSUO Masaru
 * @copyright 2010 MATSUO Masaru
 * @license   http://opensource.org/licenses/bsd-license.php New BSD License
 *
 */
/**
 * ValidatorFactory
 *
 * @package   Haraiso/validate
 * @author    MATSUO Masaru
 */
class ValidatorFactory {

    /**
     * create
     *
     * @param string $name
     * @param array  $validators
     * @return AbstractValidator
     */
    public static function create($name, $validators = array()) {
        $clazz = str_replace('@', '', $name);
        $hash = array();
        if (preg_match('/\((.*?\))/', $name, $matches) === 1) {
            $clazz = str_replace($matches[0], '', $clazz);
            $args = explode(',', str_replace(array('(', ')', ' '), '', $matches[0]));
            foreach ($args as $arg) {
                $arr = explode('=', $arg);
                if (count($arr) === 2) {
                    $vals = explode('|', $arr[1]);
                    if (count($vals) > 1) {
                        $hash[$arr[0]] = $vals;
                    } else {
                        $hash[$arr[0]] = $arr[1];
                    }
                }
            }
        }
        if (in_array($clazz, $validators) === false) return new NullValidator();
        $validator = new $clazz;
        if (count($hash) !== 0) $validator->_args = $hash;
        return $validator;
    }
}