<?php
/**
 * Haraiso - the PHP Validation Framework
 *
 * PHP version 5
 *
 * @category  Haraiso
 * @package   Haraiso/validator/impl
 * @link      http://bitbucket.org/localdisk/haraiso/
 * @author    MATSUO Masaru
 * @copyright 2010 MATSUO Masaru
 * @license   http://opensource.org/licenses/bsd-license.php New BSD License
 *
 */
/**
 * Email
 *
 * @package   Haraiso/validate/impl
 * @author    MATSUO Masaru
 */
class Email extends AbstractValidator {

    private static $REGEX = '/^[a-z0-9!#$%&\'*+\/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&\'*+\/=?^_`{|}~-]+)*@(?:[a-z0-9][-a-z0-9]*\.)*(?:[a-z0-9][-a-z0-9]{0,62})\.(?:(?:[a-z]{2}\.)?[a-z]{2,4}|museum|travel)$/i';

    /**
     * validate
     *
     * @param  mixed  $val
     * @param  string $name
     * @return bool|Message
     */
    public function validate($val, $name) {
        if (is_string($val) === false) {
            return new Message($name, $val, parent::getMessage($this->_key, $this->_args['arg']));
        }
        if ($val === '') {
            return new Message($name, $val, parent::getMessage($this->_key, $this->_args['arg']));
        }
        if (preg_match(self::$REGEX, $val) === 0) {
            return new Message($name, $val, parent::getMessage($this->_key, $this->_args['arg']));
        }
        return true;
    }
}
