<?php
/**
 * Haraiso - the PHP Validation Framework
 *
 * PHP version 5
 *
 * @category  Haraiso
 * @package   Haraiso/validator/impl
 * @link      http://bitbucket.org/localdisk/haraiso/
 * @author    MATSUO Masaru
 * @copyright 2010 MATSUO Masaru
 * @license   http://opensource.org/licenses/bsd-license.php New BSD License
 *
 */
/**
 * Ext
 *
 * @package   Haraiso/validate/impl
 * @author    MATSUO Masaru
 */
class Ext extends AbstractValidator {

    private static $EXT = array('jpg', 'gif', 'png', 'bmp');

    /**
     * validate
     *
     * @param  mixed  $val
     * @param  string $name
     * @return bool|Message
     */
    public function validate($val, $name) {
        if (is_string($val) === false) {
            return new Message($name, $val, parent::getMessage($this->_key, $this->_args['arg']));
        }
        if ($val === '') {
            return new Message($name, $val, parent::getMessage($this->_key, $this->_args['arg']));
        }
        $extentions = isset ($this->_args['ext']) ? (array) $this->_args['ext'] : self::$EXT;
        $format = substr($val, strpos($val, '.') + 1);
        if (in_array($format, $extentions) === false) {
            return new Message($name, $val, parent::getMessage($this->_key, $this->_args['arg']));
        }
        return true;
    }
}