<?php
/**
 * Haraiso - the PHP Validation Framework
 *
 * PHP version 5
 *
 * @category  Haraiso
 * @package   Haraiso/validator/impl
 * @link      http://bitbucket.org/localdisk/haraiso/
 * @author    MATSUO Masaru
 * @copyright 2010 MATSUO Masaru
 * @license   http://opensource.org/licenses/bsd-license.php New BSD License
 *
 */
/**
 * Hankana
 *
 * @package   Haraiso/validate/impl
 * @author    MATSUO Masaru
 */
class Hankana extends AbstractValidator {

    private static $REGEX = '/(?:\xEF\xBD[\xA1-\xBF]|\xEF\xBE[\x80-\x9F])/';
    /**
     * validate
     *
     * @param  mixed  $val
     * @param  string $name
     * @return bool|Message
     */
    public function validate($val, $name) {
        if (is_string($val) === false) {
            return new Message($name, $val, parent::getMessage($this->_key, $this->_args['arg']));
        }
        if ($val === '') {
            return new Message($name, $val, parent::getMessage($this->_key, $this->_args['arg']));
        }
        if (preg_replace(self::$REGEX, '', $val) !== '') {
            return new Message($name, $val, parent::getMessage($this->_key, $this->_args['arg']));
        }
        return true;
    }
}