<?php
/**
 * Haraiso - the PHP Validation Framework
 *
 * PHP version 5
 *
 * @category  Haraiso
 * @package   Haraiso/validator/impl
 * @link      http://bitbucket.org/localdisk/haraiso/
 * @author    MATSUO Masaru
 * @copyright 2010 MATSUO Masaru
 * @license   http://opensource.org/licenses/bsd-license.php New BSD License
 *
 */
/**
 * Length
 *
 * @package   Haraiso/validate/impl
 * @author    MATSUO Masaru
 */
class Length extends AbstractValidator {

    /**
     * validate
     *
     * @param  mixed  $val
     * @param  string $name
     * @return bool|Message
     */
    public function validate($val, $name) {
        if (extension_loaded('mbstring') === false) throw new Exception('mbstring extention not found.');
        $min = isset ($this->_args['min']) ? $this->_args['min'] : null;
        $max = isset ($this->_args['max']) ? $this->_args['max'] : null;
        if ($min > mb_strlen($val)) {
            return new Message($name, $val, parent::getMessage($this->_key, $this->_args['arg']));
        }
        if ($max < mb_strlen($val)) {
            return new Message($name, $val, parent::getMessage($this->_key, $this->_args['arg']));
        }
        return true;
    }
}