<?php
/**
 * Haraiso - the PHP Validation Framework
 *
 * PHP version 5
 *
 * @category  Haraiso
 * @package   Haraiso/validator/impl
 * @link      http://bitbucket.org/localdisk/haraiso/
 * @author    MATSUO Masaru
 * @copyright 2010 MATSUO Masaru
 * @license   http://opensource.org/licenses/bsd-license.php New BSD License
 *
 */
/**
 * Url
 *
 * @package   Haraiso/validate/impl
 * @author    MATSUO Masaru
 */
class Url extends AbstractValidator {

    /**
     * validate
     *
     * @param  mixed  $val
     * @param  string $name
     * @return bool|Message
     */
    public function validate($val, $name) {
        if (filter_var($val, FILTER_VALIDATE_URL, FILTER_FLAG_HOST_REQUIRED) === false) {
            return new Message($name, $val, parent::getMessage($this->_key, $this->_args['arg']));
        }
        return true;
    }
}